<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Unwinding library in Rust and for Rust"><meta name="keywords" content="rust, rustlang, rust-lang, unwinding"><title>unwinding - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate unwinding</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.1.4</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#modules">Modules</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../unwinding/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">unwinding</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/unwinding/lib.rs.html#1-48">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><h2 id="unwinding-library-in-rust-and-for-rust"><a href="#unwinding-library-in-rust-and-for-rust">Unwinding library in Rust and for Rust</a></h2>
<p><a href="https://crates.io/crates/unwinding"><img src="https://img.shields.io/crates/v/unwinding.svg" alt="crates.io" /></a>
<a href="https://docs.rs/unwinding"><img src="https://docs.rs/unwinding/badge.svg" alt="docs.rs" /></a>
<a href="https://crates.io/crates/unwinding"><img src="https://img.shields.io/crates/l/unwinding.svg" alt="license" /></a></p>
<p>This library serves two purposes:</p>
<ol>
<li>Provide a pure Rust alternative to libgcc_eh or libunwind.</li>
<li>Provide easier unwinding support for <code>#![no_std]</code> targets.</li>
</ol>
<p>Currently supports x86_64, x86, RV64 and AArch64.</p>
<h3 id="unwinder"><a href="#unwinder">Unwinder</a></h3>
<p>The unwinder can be enabled with <code>unwinder</code> feature. Here are the feature gates related to the unwinder:</p>
<div><table><thead><tr><th>Feature</th><th>Default</th><th>Description</th></tr></thead><tbody>
<tr><td>unwinder</td><td>Yes</td><td>The primary feature gate to enable the unwinder</td></tr>
<tr><td>fde-phdr-dl</td><td>Yes</td><td>Use <code>dl_iterator_phdr</code> to retrieve frame unwind table. Depends on libc.</td></tr>
<tr><td>fde-phdr-aux</td><td>No</td><td>Use ELF auxiliary vector to retrieve frame unwind table. Depends on libc.</td></tr>
<tr><td>fde-registry</td><td>Yes</td><td>Provide <code>__register__frame</code> and others for dynamic registration. Requires either <code>libc</code> or <code>spin</code> for a mutex implementation.</td></tr>
<tr><td>fde-gnu-eh-frame-hdr</td><td>No</td><td>Use <code>__executable_start</code>, <code>__etext</code> and <code>__GNU_EH_FRAME_HDR</code> to retrieve frame unwind table. The former two symbols are usually provided by the linker, while the last one is provided if GNU LD is used and –eh-frame-hdr option is enabled.</td></tr>
<tr><td>fde-static</td><td>No</td><td>Use <code>__executable_start</code>, <code>__etext</code> and <code>__eh_frame</code> to retrieve frame unwind table. The former two symbols are usually provided by the linker, while the last one would need to be provided by the user via linker script.</td></tr>
<tr><td>dwarf-expr</td><td>Yes</td><td>Enable the dwarf expression evaluator. Usually not necessary for Rust</td></tr>
<tr><td>hide-trace</td><td>Yes</td><td>Hide unwinder frames in back trace</td></tr>
</tbody></table>
</div>
<p>If you want to use the unwinder for other Rust (C++, or any programs that utilize the unwinder), you can build the <a href="cdylib"><code>unwinding_dyn</code></a> crate provided, and use <code>LD_PRELOAD</code> to replace the system unwinder with it.</p>
<div class="example-wrap"><pre class="language-sh"><code>cd cdylib
cargo build --release
LD_PRELOAD=`../target/release/libunwinding_dyn.so` rustc +nightly -Ztreat-err-as-bug</code></pre></div>
<p>If you want to link to the unwinder in a Rust binary, simply add</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">unwinding</span>;</code></pre></div>
<h3 id="personality-and-other-utilities"><a href="#personality-and-other-utilities">Personality and other utilities</a></h3>
<p>The library also provides Rust personality function. This can work with the unwinder described above or with a different unwinder. This can be handy if you are working on a <code>#![no_std]</code> binary/staticlib/cdylib and you still want unwinding support.</p>
<p>Here are the feature gates related:</p>
<div><table><thead><tr><th>Feature</th><th>Default</th><th>Description</th></tr></thead><tbody>
<tr><td>personality</td><td>No</td><td>Provides <code>#[lang = eh_personality]</code></td></tr>
<tr><td>print</td><td>No</td><td>Provides <code>(e)?print(ln)?</code>. This is really only here because panic handler needs to print things. Depends on libc.</td></tr>
<tr><td>panicking</td><td>No</td><td>Provides a generic <code>begin_panic</code> and <code>catch_unwind</code>. Only stack unwinding functionality is provided, memory allocation and panic handling is left to the user.</td></tr>
<tr><td>panic</td><td>No</td><td>Provides Rust <code>begin_panic</code> and <code>catch_unwind</code>. Only stack unwinding functionality is provided and no printing is done, because this feature does not depend on libc.</td></tr>
<tr><td>panic-handler</td><td>No</td><td>Provides <code>#[panic_handler]</code>. Provides similar behaviour on panic to std, with <code>RUST_BACKTRACE</code> support as well. Stack trace won’t have symbols though. Depends on libc.</td></tr>
<tr><td>system-alloc</td><td>No</td><td>Provides a global allocator which calls <code>malloc</code> and friends. Provided for convience.</td></tr>
</tbody></table>
</div>
<p>If you are writing a <code>#![no_std]</code> program, simply enable <code>personality</code>, <code>panic-handler</code> and <code>system-alloc</code> in addition to the defaults, you instantly obtains the ability to do unwinding! An example is given in the <a href="example"><code>example/</code> folder</a>.</p>
<h3 id="baremetal"><a href="#baremetal">Baremetal</a></h3>
<p>To use this library for baremetal projects, disable default features and enable <code>unwinder</code>, <code>fde-static</code>, <code>personality</code>, <code>panic</code>. <code>dwarf-expr</code> and <code>hide-trace</code> are optional. Modify the linker script by</p>
<div class="example-wrap"><pre class="language-ld"><code>/* Inserting these two lines */
. = ALIGN(8);
PROVIDE(__eh_frame = .);
/* before .eh_frame rule */
.eh_frame : { KEEP (*(.eh_frame)) *(.eh_frame.*) }</code></pre></div>
<p>And that’s it! After you ensured that the global allocator is functional, you can use <code>unwinding::panic::begin_panic</code> to initiate an unwing and catch using <code>unwinding::panic::catch_unwind</code>, as if you have a <code>std</code>.</p>
<p>If your linker supports <code>--eh-frame-hdr</code> you can also try to use <code>fde-gnu-eh-frame-hdr</code> instead of <code>fde-static</code>. GNU LD will provides a <code>__GNU_EH_FRAME_HDR</code> magic symbol so you don’t have to provide <code>__eh_frame</code> through linker script.</p>
<p>If you have your own version of <code>thread_local</code> and <code>println!</code> working, you can port <a href="src/panic_handler.rs"><code>panic_handler.rs</code></a> for double-panic protection and stack traces!</p>
</div></details><h2 id="modules" class="small-section-header"><a href="#modules">Modules</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="mod" href="abi/index.html" title="unwinding::abi mod">abi</a></div><div class="item-right docblock-short"></div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="unwinding" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>